{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O+,P-,Q-,R-,S-,T-,V-,X+}
{$M 4096,0,262144}

{$DEFINE PLAYAUDIO}

program tantro;

uses
  cgalib,
  scrolly,
  rotozoom,
  {$IFDEF PLAYAUDIO}
  mt_glob,
  mt_song,
  mt_play,
  mt_outp,
  {$ENDIF}
  support;

const
  stext1:string=' ...Phear Tandy 1000 powa! ';
  stext2:string=' Coded at the partyplace by Trixter/Hornet with audio by Necros! ';
  stext3:string=' See you next party... ';
  stext4:string=' End of demo, press ESC!    ';

type
  vidtype=(cga,rca,pcjrg);
  sndtype=(pc,pcjrs,nosound);

var
  vs:pvidSystem;
  s1loc:pointer;
  curpos:byte;
  foostring:string;
  fooidx:byte;
  scounter:word;
  rz:trotozoomer;
  oldma:longint;
  {$IFDEF PLAYAUDIO}
  MySong:PSong; {make sure you init as a descendant, like PMTSong}
  MyOutput:POutputDevice; {make sure to init as descendant, like PPCSpeakerSimple}
  MyPlayer:PPlayerEngine; {make sure to init as descendant, like PMTV1Player}
  sndchoice:sndtype;
  {$ENDIF}
  foo:char;
  vidchoice:vidtype;

{$IFDEF PLAYAUDIO}
Procedure InitPlaySubsystem;

begin
  {init player, passing song to it so it knows what to play}
  MyPlayer:=new(PMTV1Player,Init(MySong));
  {...then the output device, with a hook to the player}
  if sndchoice=pcjrs
    then MyOutput:=new(PSN76489,Init(MyPlayer))
    else MyOutput:=new(PPCSpeakerSimple,Init(MyPlayer,false));
  {Cross your fingers:}
  MyOutput^.hookPlayer(playerTimeSliceFreq);
end;

Procedure KillPlaySubSystem;
begin
  {stop the interrupt}
  MyOutput^.unHookPlayer;
  {order is important!}
  Dispose(MyOutput,Done);
  Dispose(MyPlayer,Done);
end;
{$ENDIF}

begin
  oldma:=memavail;

  writeln(#13#10'Choose graphics mode: '#13#10'1. CGA RGB'#13#10'2. CGA Composite'#13#10'3. Tandy/PCjr');
  foo:=readkeychar;
  case foo of
    '1':vidchoice:=cga;
    '2':vidchoice:=rca;
    '3':vidchoice:=pcjrg;
  else  vidchoice:=cga;
  end; {case}
  {$IFDEF PLAYAUDIO}
  writeln(#13#10'Choose sound device: '#13#10'1. Silence'#13#10'2. PC Speaker'#13#10'2. Tandy/PCjr audio');
  foo:=readkeychar;
  case foo of
    '1':sndchoice:=nosound;
    '2':sndchoice:=pc;
    '3':sndchoice:=pcjrs;
  else  sndchoice:=nosound;
  end; {case}
  {$ENDIF}
  case vidchoice of
    cga  :vs:=new(pvidCGAGmode4,    Init(mode4,true));
    rca  :vs:=new(pvidCGAGcomposite,Init(composite,true));
    pcjrg:vs:=new(pvidTANG160,      Init(tan160,true));
  end;
  s1loc:=ptr($b800,((99-8)*80)+79);
  foostring:=stext1;  fooidx:=0;
  rz.init(vs,ptr($b800,10*80{0000}),80);

  {$IFDEF PLAYAUDIO}
  if sndchoice<>nosound then begin
    MySong:=new(PMTSong,init(3));
    InitPlaySubsystem;
    {load song}
    MyPlayer^.Send(pa_Stop);
    if Mysong^.load('music.mon')
      then begin
        {if song load was successful, re-init the playback subsystem because
        the number of tracks may have changed!}
        KillPlaySubsystem;
        InitPlaySubsystem;
      end else begin
        asm
          mov ax,0003
          int 10h
        end;
        writeln('Failed to load song!');
        halt;
      end;
    {tell it to play}
    {writeln('playing');}
    MyPlayer^.Send(pa_playsong);
  end;
  {$ENDIF}
  vs^.setdrawpage(visible);
  vs^.clear(0);

  repeat
    vs^.WaitVertRetrace;
    rz.draw; {draw a rotozoomer frame}
    {vs.pageflip;}
    scounter:=scrollonce(foostring,s1loc,1+fooidx);
    {if at end of our scrolltext then move to next one}
    if scounter=0 then fooidx:=((fooidx+1) AND 3);
      case fooidx of
        0:foostring:=stext1;
        1:foostring:=stext2;
        2:foostring:=stext3;
        3:foostring:=stext4;
      end; {case}
  until keypressed; if keypressed then readkeychar;

  {$IFDEF PLAYAUDIO}
  if sndchoice<>nosound then begin
    killPlaySubsystem;
    dispose(mySong,Done);
  end;
  {$ENDIF}

  rz.done;
  dispose(vs,done);
  writeln('Greets to Polaris, Gargaj, Virt, Sketchcow, tfinn, Barzoule, Blacklight,');
  writeln('yesso, madbrain, The Fat Man and Circuit Girl, IC, Radman, Sigflup, Joe Snow,');
  writeln('and anyone else who talked to me at length that I''m forgetting here...');
  {check for memory leak}
  if memavail<>oldma then writeln(#13#10'Memory leak of ',oldma-memavail,' bytes detected :-(');

end.
